C*
      SUBROUTINE OPNFIL(LFN,FILNAM,STATUS,FORM,ACTION,RESERV,IOSTAT)
CC
CC NAME       : OPNFIL
CC
CC PURPOSE    : OPEN FILE
CC
CC PARAMETERS :
CC         IN : LFN        : LOGICAL FILENUMBER                     I*4
CC              FILNAM     : FILENAME OF FILE TO BE OPENED         CH*(*)
CC              STATUS     : 'OLD','NEW','UNKNOWN','SCRATCH'       CH*(*)
CC              FORM       : 'FORMATTED','UNFORMATTED','BINARY'    CH*(*)
CC              ACTION     : 'READONLY',' '                        CH*(*)
CC              RESERV     : RESERVED                              CH*(*)
CC        OUT : IOSTAT     : STATUS                                 I*4
CC
CC REMARKS    : SEE COMMENTS FOR DIFFERENT DIALECTS
CC
CC SR CALLED  : UPPERC,SJUSTL
CC
CC COPYRIGHT  :  ASTRONOMICAL INSTITUTE   INSTITUTE FOR APPIELD GEODESY
CC      1989      UNIVERSITY OF BERNE            FRANKFURT/MAIN
CC                    SWITZERLAND                    GERMANY
CC
CC CREATED    : 25-APR-91               LAST MODIFIED :  22-OCT-97
CC
CC CHANGES    : 23-AUG-93 : "BINARY" SIMULATED WITH DIRECT ACCESS
CC              23-AUG-94 : MR: CALL EXITRC
CC              26-SEP-94 : JJ: PUT FILNAM INTO A STRING SO IT CAN
CC                              BE PASSED IN AS A CONSTANT
CC              28-FEB-96 : UNIFIED (UNIX,VMS,LAHEY)
CC              03-APR-96 : MR: CORRECT _END_
CC              07-MAY-96 : MR: NEW SYSTEM DEFINITIONS (UNDERSCORE)
CC                              USE SUBROUTINE "SYSTYP"
CC              30-JAN-97 : WG: BINARY OPEN FOR DEC_OSF1
CC              05-FEB-97 : JJ: USE SYSNAM INSTEAD OF SYSTYP
CC              22-OCT-97 : MR: OPEN FORMATTED FILES WITH RECL=1024
CC
C*
      CHARACTER FILNAM*(*),STATUS*(*),FORM*(*),ACTION*(*),RESERV*(*)
      CHARACTER*80 FLNAMU
      CHARACTER*32 STYPEN
      CHARACTER*20 TEST,ST,FO,AC
      LOGICAL   OPENED
C
C  LEFT-JUSTIFY FILENAME (AS A PRECAUTION!)
      FLNAMU=FILNAM
      CALL SJUSTL(FLNAMU)
C
C  CLOSE FILE IF IT HAS BEEN OPENED BEFORE
      INQUIRE(FILE=FLNAMU,OPENED=OPENED,NUMBER=LFNTST)
      IF(OPENED) CLOSE(UNIT=LFNTST)
C
      TEST=STATUS
      CALL UPPERC(TEST)
      IF(TEST.EQ.'NEW') THEN
C_BEG_UNIX + LAHEY
C       ST='UNKNOWN'
C_END_UNIX + LAHEY
C_BEG_VMS
        ST=TEST
C_END_VMS
C
C  DEFAULT
      ELSEIF (TEST.EQ.' ') THEN
        ST='UNKNOWN'
      ELSEIF (TEST.EQ.'UNKNOWN') THEN
        ST=TEST
      ELSEIF (TEST.EQ.'SCRATCH') THEN
        ST=TEST
      ELSEIF (TEST.EQ.'OLD') THEN
        ST=TEST
      ELSE
        GOTO 920
      END IF
C
      TEST=FORM
      CALL UPPERC(TEST)
      IF(TEST.EQ.'FORMATTED') THEN
        FO=TEST
C DEFAULT
      ELSEIF (TEST.EQ.' ') THEN
        FO='FORMATTED'
      ELSEIF (TEST.EQ.'UNFORMATTED') THEN
        FO=TEST
      ELSEIF (TEST.EQ.'BINARY') THEN
        FO=TEST
      ELSE
        GOTO 920
      END IF
C
C  READONLY OR SHARED READING
C
      TEST=ACTION
      CALL UPPERC(TEST)
      IF(TEST.EQ.'READONLY') THEN
C_BEG_LAHEY
C       AC='READ,DENYWRITE'
C_END_LAHEY
C_BEG_UNIX
C       AC=' '
C_END_UNIX
C_BEG_VMS
        AC='READONLY'
C_END_VMS
      ELSEIF (TEST.EQ.' ') THEN
        AC=' '
      ELSE
        GOTO 920
      END IF
C
C  OPEN FILE
C  ---------
C
C_BEG_VMS
      IF(FO.EQ.'FORMATTED') THEN
        IF(AC.EQ.' ') THEN
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
     1         RECL=1024,CARRIAGECONTROL='LIST')
        ELSE
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
     1         RECL=1024,CARRIAGECONTROL='LIST',READONLY)
        END IF
      ELSEIF(FO.EQ.'UNFORMATTED') THEN
        IF(AC.EQ.' ') THEN
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT)
        ELSE
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
     1         READONLY)
        END IF
      ELSEIF(FO.EQ.'BINARY') THEN
        IF(AC.EQ.' ') THEN
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM='UNFORMATTED',
     1         ACCESS='DIRECT',RECL=128,IOSTAT=IOSTAT)
        ELSE
          OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM='UNFORMATTED',
     1         ACCESS='DIRECT',RECL=128,IOSTAT=IOSTAT,READONLY)
        END IF
      END IF
C_END_VMS
C
C_BEG_UNIX
C     CALL SYSNAM(STYPEN)
C     IF(FO.NE.'BINARY') THEN
C       OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT)
C     ELSE
C
CC SIMULATE "BINARY" WITH DIRECT ACCESS
C       IF(STYPEN(1:8).NE.'DEC_OSF1') THEN
C         LRECL=512
C       ELSE
C         LRECL=128
C       END IF
C       OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM='UNFORMATTED',
C    1       ACCESS='DIRECT',RECL=LRECL,IOSTAT=IOSTAT)
C
C     END IF
C     IF(STYPEN(1:7).EQ.'IBM_AIX') THEN
C       IF(ST.EQ.'OLD'.AND.IOSTAT.EQ.0.AND.FO.NE.'BINARY') REWIND LFN
C     ENDIF
C_END_UNIX
C
C_BEG_LAHEY
C     IF(FO.EQ.'FORMATTED') THEN
C       IF(AC.EQ.' ') THEN
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
C    1         RECL=255)
C       ELSE
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
C    1         RECL=255,ACTION=AC)
C       END IF
C     ELSEIF(FO.EQ.'UNFORMATTED') THEN
C       IF(AC.EQ.' ') THEN
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT)
C       ELSE
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM=FO,IOSTAT=IOSTAT,
C    1         ACTION=AC)
C       END IF
C     ELSEIF(FO.EQ.'BINARY') THEN
C       IF(AC.EQ.' ') THEN
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM='UNFORMATTED',
C    1         ACCESS='TRANSPARENT',IOSTAT=IOSTAT)
C       ELSE
C         OPEN(UNIT=LFN,FILE=FLNAMU,STATUS=ST,FORM='UNFORMATTED',
C    1         ACTION=AC,ACCESS='TRANSPARENT',IOSTAT=IOSTAT)
C       END IF
C     END IF
C_END_LAHEY
C
      RETURN
C
920   WRITE(*,921) TEST,LFN,FLNAMU
921   FORMAT(/,' SR OPNFIL: UNKNOWN KEYWORD    : ',A,
     1       /,'            LOGICAL FILENUMBER : ',I2,
     2       /,'            FILENAME           : ',A,/)
      CALL EXITRC(2)
C
      END
